package org.herac.tuxguitar_alsa.plugin.synth;
import javax.sound.midi.MidiChannel;
import javax.sound.midi.MidiUnavailableException;

public class MidiChannelImpl implements MidiChannel{
	private int channel;
	private MidiSynthesizerImpl synthesizer;	
	
	public MidiChannelImpl(int channel,MidiSynthesizerImpl synthesizer){
		this.channel = channel;
		this.synthesizer = synthesizer;
	}
	
	public void noteOn(int noteNumber, int velocity) {
		try {
			getSynthesizer().getReceiver().noteOn(channel,noteNumber,velocity);
		} catch (MidiUnavailableException e) {
			e.printStackTrace();
		}		
	}

	public void noteOff(int noteNumber, int velocity) {
		try {
			getSynthesizer().getReceiver().noteOff(channel,noteNumber,velocity);
		} catch (MidiUnavailableException e) {
			e.printStackTrace();
		}		
	}

	public void noteOff(int noteNumber) {
		try {
			getSynthesizer().getReceiver().noteOff(channel,noteNumber,0);
		} catch (MidiUnavailableException e) {
			e.printStackTrace();
		}
	}

	public void setPolyPressure(int noteNumber, int pressure) {		
	}

	public int getPolyPressure(int noteNumber) {
		return 0;
	}

	public void setChannelPressure(int pressure) {		
	}

	public int getChannelPressure() {
		return 0;
	}

	public void controlChange(int controller, int value) {
		try {					
			getSynthesizer().getReceiver().controlChange(channel,controller,value);
		} catch (MidiUnavailableException e) {
			e.printStackTrace();
		}
	}	
	
	public int getController(int controller) {
		return 0;
	}

	public void programChange(int program) {
		programChange(0,program);
	}

	public void programChange(int bank, int program) {
		try {
			getSynthesizer().getReceiver().programChange(channel,program);
		} catch (MidiUnavailableException e) {
			e.printStackTrace();
		}
	}

	public int getProgram() {
		return 0;
	}

	public void setPitchBend(int bend) {		
	}

	public int getPitchBend() {
		return 0;
	}

	public void resetAllControllers() {		
	}

	public void allNotesOff() {
		
	}

	public void allSoundOff() {		
	}

	public boolean localControl(boolean on) {
		return false;
	}

	public void setMono(boolean on) {		
	}

	public boolean getMono() {
		return false;
	}

	public void setOmni(boolean on) {		
	}

	public boolean getOmni() {
		return false;
	}
	
	public boolean getMute() {
		return false;
	}

	public boolean getSolo() {
		return false;
	}

	public void setMute(boolean mute) {		
	}

	public void setSolo(boolean soloState) {		
	}

	private MidiSynthesizerImpl getSynthesizer(){
		return synthesizer;
	}

}
